include('shared.lua')

SWEP.PrintName			= "Modern Warfare Weapon Base"			-- 'Nice' Weapon name (Shown on HUD)	
SWEP.Slot				= 0							-- Slot in the weapon selection menu
SWEP.SlotPos			= 1							-- Position in the slot
SWEP.DrawAmmo			= true						-- Should draw the default HL2 ammo counter?
SWEP.DrawCrosshair		= false 						-- Should draw the default crosshair?
SWEP.DrawWeaponInfoBox		= true						-- Should draw the weapon info box?
SWEP.BounceWeaponIcon   	= false						-- Should the weapon icon bounce?
SWEP.SwayScale			= 1.0							-- The scale of the viewmodel sway
SWEP.BobScale			= 1.0							-- The scale of the viewmodel bob

	SWEP.WeaponSelectIconLetter	= "B"
	SWEP.DrawAmmo			= true
	--SWEP.DrawCrosshair		= false
	SWEP.DrawWeaponInfoBox		= true					-- Should draw the weapon info box
	SWEP.BounceWeaponIcon		= false					-- Should the weapon icon bounce?
	SWEP.SwayScale			= 1.0					-- The scale of the viewmodel sway
	SWEP.BobScale			= 1.0					-- The scale of the viewmodel bob
	SWEP.WepSelectIcon		= surface.GetTextureID( "killicons" )
	SWEP.ViewModelFOV		= 55
	SWEP.ViewModelFlip		= false
	SWEP.CSMuzzleFlashes		= false

	-- This is the font that's used to draw the death icons
	surface.CreateFont( "csd", ScreenScale( 30 ), 500, true, true, "CSKillIcons" )
	surface.CreateFont( "csd", ScreenScale( 60 ), 500, true, true, "CSSelectIcons" )
	surface.CreateFont( "Counter-Strike", ScreenScale( 60 ), 500, true, true, "CSSelectIconsz" )


SWEP.RenderGroup 			= RENDERGROUP_OPAQUE

surface.CreateFont( "csd", ScreenScale( 30 ), 500, true, true, "CSKillIcons" )
surface.CreateFont( "csd", ScreenScale( 60 ), 500, true, true, "CSSelectIcons" )
surface.CreateFont( "Counter-Strike", ScreenScale( 60 ), 500, true, true, "CSSelectIconsz" )

language.Add("airboatgun_ammo", "5.56MM Ammo")					-- AirboatGun			= 5.56MM Ammo (M249, FAMAS, SG-550, SG-552, Galil, M4A1)
language.Add("gravity_ammo", "4.6MM Ammo")					-- Gravity				= 4.6MM Ammo (MP7)
language.Add("alyxgun_ammo", "5.7MM Ammo")					-- AlyxGun 				= 5.7MM Ammo (Five-Seven, P90)
language.Add("battery_ammo", "9MM Ammo")						-- Battery 				= 9MM Ammo (Glock, MP5, P228, USP, TMP)
language.Add("striderminigun_ammo", "7.62MM Ammo")				-- StriderMinigun 		= 7.62MM Ammo (AK-47, SCOUT, G3, Aug, AWP, Scout)
language.Add("sniperpenetratedround_ammo", ".45 Ammo")			-- SniperPenetratedRound	= .45 Ammo (MAC10, UMP)
language.Add("combinecannon_ammo", ".50 Ammo")					-- CombineCannon			= .50 Ammo (Desert Eagle)
language.Add("thumper_ammo", "Explosive Ammo")					-- Thumper				= Explosive Ammo (C4)

/*---------------------------------------------------------
   Name: SWEP:SecondDrawHUD()
---------------------------------------------------------*/
function SWEP:SecondDrawHUD()
end

/*---------------------------------------------------------
	DrawHUD	
---------------------------------------------------------*/
function SWEP:DrawHUD()
	local trace = {}
	trace.start = spos
	trace.endpos = self.Owner:GetEyeTrace().HitPos
	trace.filter = self.Owner
	
	local tr = util.TraceLine(trace)
	
	
	local x = ScrW() / 2.0
	local y = ScrH() / 2.0 
	
	surface.SetDrawColor( 191, 210, 255, 240 - 240 )

	if (!self.Owner:KeyDown(IN_SPEED) and !self.Weapon:GetDTBool(1)) and (!self.Owner:KeyDown(IN_FORWARD) or !self.Owner:KeyDown(IN_BACK) or !self.Owner:KeyDown(IN_RIGHT) or !self.Owner:KeyDown(IN_LEFT)) then
	surface.DrawLine( x, y, x+10, y )
	surface.DrawLine( x, y, x-10, y )
	surface.DrawLine( x, y, x, y+5 )
	surface.DrawLine( x, y, x, y-5 )
	end
end

/*---------------------------------------------------------
	Checks the objects before any action is taken
	This is to make sure that the entities haven't been removed
---------------------------------------------------------*/
function SWEP:DrawWeaponSelection( x, y, wide, tall, alpha )

	draw.SimpleText( self.WeaponSelectIconLetter, "CSSelectIconsz", x + wide/2, y + tall*0.2, Color( 255, 189, 6, 255 ), TEXT_ALIGN_CENTER )

	if (self.ShakeWeaponSelectIcon == true) then
		draw.SimpleText( self.WeaponSelectIconLetter, "CSSelectIconsz", x + wide/2 + math.Rand(-4, 4), y + tall*0.2+ math.Rand(-14, 14), Color( 255, 210, 0, math.Rand(10, 120) ), TEXT_ALIGN_CENTER )
		draw.SimpleText( self.WeaponSelectIconLetter, "CSSelectIconsz", x + wide/2 + math.Rand(-4, 4), y + tall*0.2+ math.Rand(-9, 9), Color( 255, 210, 0, math.Rand(10, 120) ), TEXT_ALIGN_CENTER )
	end

end

/*---------------------------------------------------------
   Name: SWEP:GetViewModelPosition()
   Desc: Allows you to re-position the view model.
---------------------------------------------------------*/
local IRONSIGHT_TIME = 0.2

function SWEP:GetViewModelPosition(pos, ang)

	local bIron = self.Weapon:GetDTBool(1)	
	
	local DashDelta = 0
	
	if (self.Owner:KeyDown(IN_SPEED) or self.Weapon:GetDTBool(0)) then
		if (!self.DashStartTime) then
			self.DashStartTime = CurTime()
		end
		
		DashDelta = math.Clamp(((CurTime() - self.DashStartTime) / 0.1) ^ 1.2, 0, 1)
	else
		if (self.DashStartTime) then
			self.DashEndTime = CurTime()
		end
	
		if (self.DashEndTime) then
			DashDelta = math.Clamp(((CurTime() - self.DashEndTime) / 0.1) ^ 1.2, 0, 1)
			DashDelta = 1 - DashDelta
			if (DashDelta == 0) then self.DashEndTime = nil end
		end
	
		self.DashStartTime = nil
	end
	
	if (DashDelta) then
		local Down = ang:Up() * -1
		local Right = ang:Right()
		local Forward = ang:Forward()
	
		local bUseVector = false
		
		if(!self.RunArmAngle.pitch) then
			bUseVector = true
		end
		
		if (bUseVector == true) then
			ang:RotateAroundAxis(ang:Right(), self.RunArmAngle.x * DashDelta)
			ang:RotateAroundAxis(ang:Up(), self.RunArmAngle.y * DashDelta)
			ang:RotateAroundAxis(ang:Forward(), self.RunArmAngle.z * DashDelta)
			
			pos = pos + self.RunArmOffset.x * ang:Right() * DashDelta 
			pos = pos + self.RunArmOffset.y * ang:Forward() * DashDelta 
			pos = pos + self.RunArmOffset.z * ang:Up() * DashDelta 
		else
			ang:RotateAroundAxis(Right, elf.RunArmAngle.pitch * DashDelta)
			ang:RotateAroundAxis(Down, self.RunArmAngle.yaw * DashDelta)
			ang:RotateAroundAxis(Forward, self.RunArmAngle.roll * DashDelta)

			pos = pos + (Down * self.RunArmOffset.x + Forward * self.RunArmOffset.y + Right * self.RunArmOffset.z) * DashDelta			
		end
		
		if (self.DashEndTime) then
			return pos, ang
		end
	end

	if (bIron != self.bLastIron) then
		self.bLastIron = bIron 
		self.fIronTime = CurTime()
		
		if (bIron) then 
			self.SwayScale 	= 0.3
			self.BobScale 	= 0.1
		else 
			self.SwayScale 	= 1.0
			self.BobScale 	= 1.0
		end
	
	end
	
	local fIronTime = self.fIronTime or 0

	if (!bIron && fIronTime < CurTime() - IRONSIGHT_TIME) then 
		return pos, ang
	end
	
	local Mul = 1.0
	
	if (fIronTime > CurTime() - IRONSIGHT_TIME) then
		Mul = math.Clamp((CurTime() - fIronTime) / IRONSIGHT_TIME, 0, 1)

		if (!bIron) then Mul = 1 - Mul end
	end

	if (self.IronSightsAng) then
		ang = ang * 1
		ang:RotateAroundAxis(ang:Right(), 	self.IronSightsAng.x * Mul)
		ang:RotateAroundAxis(ang:Up(), 	self.IronSightsAng.y * Mul)
		ang:RotateAroundAxis(ang:Forward(), self.IronSightsAng.z * Mul)
	end
	
	local Right 	= ang:Right()
	local Up 		= ang:Up()
	local Forward 	= ang:Forward()
	
	pos = pos + self.IronSightsPos.x * Right * Mul
	pos = pos + self.IronSightsPos.y * Forward * Mul
	pos = pos + self.IronSightsPos.z * Up * Mul
	
	return pos, ang
end

/*---------------------------------------------------------
   Name: SWEP:AdjustMouseSensitivity()
   Desc: Allows you to adjust the mouse sensitivity.
---------------------------------------------------------*/
function SWEP:AdjustMouseSensitivity()

	return nil
end

/*---------------------------------------------------------
   Name: SWEP:GetTracerOrigin()
   Desc: Allows you to override where the tracer comes from (in first person view)
	   returning anything but a vector indicates that you want the default action.
---------------------------------------------------------*/
function SWEP:GetTracerOrigin()

	if (self.Weapon:GetDTBool(1)) then
		local pos = self:GetOwner():EyePos() + self:GetOwner():EyeAngles():Up() * -4
		return pos
	end
end