
/*---------------------------------------------------------

  This file should contain variables and functions that are 
   the same on both client and server.

  This file will get sent to the client - so don't add 
   anything to this file that you don't want them to be
   able to see.
   
  Though, you shouldn't be here.

---------------------------------------------------------*/

include( 'obj_player_extend.lua' )

include( 'gravitygun.lua' )
include( 'player_shd.lua' )
include( 'animations.lua' )

GM.Name 		= "City Life"
GM.Author 		= "WolfosoBastardo"
GM.Email 		= "lonerwolf1@live.it"
GM.Website 		= ""
GM.TeamBased 	= false

DeriveGamemode("sandbox")
AddCSLuaFile("thirdperson.lua")

ThirdPerson = {}

// -----------------------------------------------------------------------------
// CLIENT
// -----------------------------------------------------------------------------

/*if CLIENT and LocalPlayer():GetNWBool("firstperson") != true then
function ThirdPerson.CalcView(player, pos, angles, fov)
	local smooth = 1--GetConVarNumber("chasecam_smooth")
	local smoothscale = 0.2--GetConVarNumber("chasecam_smoothscale")
		angles = player:GetAimVector():Angle()

		local targetpos = Vector(0, 0, 60)
		if player:KeyDown(IN_DUCK) then
			if player:GetVelocity():Length() > 0 then
				targetpos.z = 50
			else
				targetpos.z = 40
			end
		end

		player:SetAngles(angles)
		local targetfov = fov
		if player:GetVelocity():DotProduct(player:GetForward()) > 10 then
			if player:KeyDown(IN_SPEED) then
				targetpos = targetpos + player:GetForward() * -10
				if player:OnGround() then
					angles.pitch = angles.pitch + 0.5 * math.sin(CurTime() * 10)
					angles.roll = angles.roll + 0.5 * math.cos(CurTime() * 10)
					targetfov = targetfov + 3
				end
			else
				targetpos = targetpos + player:GetForward() * -5
			end
		end 

		// tween to the target position
		pos = player:GetVar("thirdperson_pos") or targetpos
		if smooth != 0 then
			pos.x = math.Approach(pos.x, targetpos.x, math.abs(targetpos.x - pos.x) * smoothscale)
			pos.y = math.Approach(pos.y, targetpos.y, math.abs(targetpos.y - pos.y) * smoothscale)
			pos.z = math.Approach(pos.z, targetpos.z, math.abs(targetpos.z - pos.z) * smoothscale)
		else
			pos = targetpos
		end
		player:SetVar("thirdperson_pos", pos)

		// offset it by the stored amounts, but trace so it stays outside walls
		// we don't tween this so the camera feels like its tightly following the mouse
		local offset = Vector(5, 5, 5)
		if player:GetActiveWeapon():IsValid() then
			if player:GetNWBool("aiming") == true and player:GetActiveWeapon():GetClass() != "weapon_physgun" and player:GetActiveWeapon():GetClass() != "cm_use" and player:GetActiveWeapon():GetClass() != "weapon_physcannon" then
				offset.x = 15--GetConVarNumber("chasecam_back")
				offset.y = 15--GetConVarNumber("chasecam_right")
				offset.z = 5--GetConVarNumber("chasecam_up")
			else
				if player:GetNWBool("classictype") == true then
				offset.x = 50--GetConVarNumber("chasecam_back")
				offset.y = 0--GetConVarNumber("chasecam_right")
				offset.z = 15--GetConVarNumber("chasecam_up")
				else
				offset.x = 36--GetConVarNumber("chasecam_back")
				offset.y = 10--GetConVarNumber("chasecam_right")
				offset.z = 10--GetConVarNumber("chasecam_up")
				end
			end
		end
		local t = {}
		t.start = player:GetPos() + pos
		t.endpos = t.start + angles:Forward() * -offset.x
		t.endpos = t.endpos + angles:Right() * offset.y
		t.endpos = t.endpos + angles:Up() * offset.z
		t.filter = player
		if player:GetScriptedVehicle():IsValid() then
			pos = t.endpos
		else
			local tr = util.TraceLine(t)
			pos = tr.HitPos
			if tr.Fraction < 1.0 then
				pos = pos + tr.HitNormal * 5
			end
		end
		player:SetVar("thirdperson_viewpos", pos)

		// tween the fov
		fov = player:GetVar("thirdperson_fov") or targetfov
		if smooth != 0 then
			fov = math.Approach(fov, targetfov, math.abs(targetfov - fov) * smoothscale)
		else
			fov = targetfov
		end
		player:SetVar("thirdperson_fov", fov)

		return GAMEMODE:CalcView(player, pos, angles, fov)
end
hook.Add("CalcView", "ThirdPerson.CalcView", ThirdPerson.CalcView)

function ThirdPerson.HUDPaint()
	local player = LocalPlayer()

	// trace from muzzle to hit pos
	local t = {}
	t.start = player:GetShootPos()
	t.endpos = t.start + player:GetAimVector() * 9000
	t.filter = player
	local tr = util.TraceLine(t)
	local pos = tr.HitPos:ToScreen()
	local fraction = math.min((tr.HitPos - t.start):Length(), 1024) / 1024
	local size = 10 + 20 * (1.0 - fraction)
	local offset = size * 0.5
	local offset2 = offset - (size * 0.1)

	t = {}
	t.start = player:GetVar("thirdperson_viewpos") or player:GetPos()
	t.endpos = tr.HitPos + tr.HitNormal * 5
	t.filter = player
	local tr = util.TraceLine(t)
		surface.SetDrawColor(209,236,255, 255)
	surface.DrawLine(pos.x - offset, pos.y, pos.x - offset2, pos.y)
	surface.DrawLine(pos.x + offset, pos.y, pos.x + offset2, pos.y)
	surface.DrawLine(pos.x, pos.y - offset, pos.x, pos.y - offset2)
	surface.DrawLine(pos.x, pos.y + offset, pos.x, pos.y + offset2)
	surface.DrawLine(pos.x - 1, pos.y, pos.x + 1, pos.y)
	surface.DrawLine(pos.x, pos.y - 1, pos.x, pos.y + 1)
end
hook.Add("HUDPaint", "ThirdPerson.HUDPaint", ThirdPerson.HUDPaint)

function ThirdPerson.HUDShouldDraw(name)
	if name == "CHudCrosshair" then
		return false
	end
end
hook.Add("HUDShouldDraw", "ThirdPerson.HUDShouldDraw", ThirdPerson.HUDShouldDraw)

function ThirdPerson.Zoom(player, command, arguments)
	if player:GetVar("thirdperson_zoom") == 1 then
		player:SetVar("thirdperson_zoom", 0)
	else
		player:SetVar("thirdperson_zoom", 1)
	end
end
concommand.Add("chasecam_zoom", ThirdPerson.Zoom)
// -----------------------------------------------------------------------------
// SERVER
// -----------------------------------------------------------------------------

else 

function ThirdPerson.Command(player, command, arguments)
	ThirdPerson.Enable(player)
end

function ThirdPerson.Disable(player)
	local entity = player:GetViewEntity()
	player:SetNetworkedInt("thirdperson", 0)
	player:SetViewEntity(player)
	entity:Remove()
end

function ThirdPerson.Enable(player)
	local entity = ents.Create("prop_dynamic")
	entity:SetModel("models/props_junk/garbage_metalcan002a.mdl")--("models/error.mdl")
	entity:DrawShadow(false)
	entity:Spawn()
	entity:SetAngles(player:GetAngles())
	entity:SetMoveType(MOVETYPE_NONE)
	entity:SetParent(player)
	entity:SetPos(player:GetPos() + Vector(0, 0, 60))
	entity:SetRenderMode(RENDERMODE_NONE)
	entity:SetSolid(SOLID_NONE)
	player:SetViewEntity(entity)
	player:SetNetworkedInt("thirdperson", 1)
end

end

// -----------------------------------------------------------------------------
// SHARED
// -----------------------------------------------------------------------------

function ThirdPerson.UpdateAnimation(player)
	if player:KeyDown(IN_SPEED) then
		player:SetPlaybackRate(1.5)
	end
end
hook.Add("UpdateAnimation", "ThirdPerson.UpdateAnimation", ThirdPerson.UpdateAnimation)
*/
	for k, v in pairs(ents.GetAll()) do
		if v:IsDoor() then
			if table.HasValue(UnOwnableDoors, v:EntIndex()) then
			v:SetNWBool("doorowned", true)
			v:SetNWBool("unownable", true)
			end
			if table.HasValue(RemoveDoors,  v:EntIndex()) then
			v:Remove()
			end
		end
	end
/*---------------------------------------------------------
 Shared part
 ---------------------------------------------------------*/
local meta = FindMetaTable("Entity")

function meta:IsVIP()
	local vip = self:SteamID()

	if vip == "" then -- STEAMID HERE :D
		return true
	end
	return false
end

function meta:IsOwnable()
	local class = self:GetClass()

	if (class == "func_door" or class == "func_door_rotating" or class == "prop_door_rotating") or
		class == "prop_vehicle_jeep" or class == "prop_vehicle_airboat" then
			return true
		end
	return false
end

function meta:IsDoor()
	local class = self:GetClass()

	if class == "func_door" or
		class == "func_door_rotating" or
		class == "prop_door_rotating" or
		class == "prop_dynamic" then
		return true
	end
	return false
end

function meta:IsOwned()
	local num = 0
	for n = 1, self:GetNWInt("OwnerCount") do
		if self:GetNWInt("Ownersz" .. n) > -1 then
			num = num + 1
		end
	end

	if ValidEntity(self:GetNWEntity("TheOwner")) or num > 0 then return true end

	return false
end

function meta:GetDoorOwner()
	return self:GetNWEntity("TheOwner")
end

function meta:IsMasterOwner(ply)
	if ply == self:GetDoorOwner() then
		return true
	end

	return false
end

function meta:OwnedBy(ply)
	if ply == self:GetDoorOwner() then return true end

	local num = self:GetNWInt("OwnerCount")

	for n = 1, num do
		if ply:EntIndex() == self:GetNWInt("Ownersz" .. n) then
			return true
		end
	end

	return false
end

function meta:AllowedToOwn(ply)
	local num = self:GetNWInt("AllowedNum")

	for n = 1, num do
		if self:GetNWInt("Allowed" .. n) == ply:EntIndex() then
			return true
		end
	end

	return false
end

/*---------------------------------------------------------
   Name: gamemode:PlayerHurt( )
   Desc: Called when a player is hurt.
---------------------------------------------------------*/
function GM:PlayerHurt( player, attacker, healthleft, healthtaken )
end


/*---------------------------------------------------------
   Name: gamemode:KeyPress( )
   Desc: Player pressed a key (see IN enums)
---------------------------------------------------------*/
function GM:KeyPress( player, key )
end


/*---------------------------------------------------------
   Name: gamemode:KeyRelease( )
   Desc: Player released a key (see IN enums)
---------------------------------------------------------*/
function GM:KeyRelease( player, key )
end


/*---------------------------------------------------------
   Name: gamemode:PlayerConnect( )
   Desc: Player has connects to the server (hasn't spawned)
---------------------------------------------------------*/
function GM:PlayerConnect( name, address )
end

/*---------------------------------------------------------
   Name: gamemode:PlayerAuthed( )
   Desc: Player's STEAMID has been authed
---------------------------------------------------------*/
function GM:PlayerAuthed( ply, SteamID, UniqueID )
end


/*---------------------------------------------------------
   Name: gamemode:PropBreak( )
   Desc: Prop has been broken
---------------------------------------------------------*/
function GM:PropBreak( attacker, prop )
end


/*---------------------------------------------------------
   Name: gamemode:PhysgunPickup( )
   Desc: Return true if player can pickup entity
---------------------------------------------------------*/
function GM:PhysgunPickup( ply, ent )

	// Don't pick up players
	if ( ent:GetClass() == "player" ) then return false end

	return true
end


/*---------------------------------------------------------
   Name: gamemode:PhysgunDrop( )
   Desc: Dropped an entity
---------------------------------------------------------*/
function GM:PhysgunDrop( ply, ent )
end


/*---------------------------------------------------------
   Name: gamemode:SetupMove( player, movedata )
   Desc: Allows us to change stuff before the engine 
		  processes the movements
---------------------------------------------------------*/
function GM:SetupMove( ply, move )
end


/*---------------------------------------------------------
   Name: gamemode:FinishMove( player, movedata )
---------------------------------------------------------*/
function GM:FinishMove( ply, move )

end

/*---------------------------------------------------------
   Name: gamemode:Move
   This basically overrides the NOCLIP, PLAYERMOVE movement stuff.
   It's what actually performs the move. 
   Return true to not perform any default movement actions. (completely override)
---------------------------------------------------------*/
function GM:Move( ply, mv )
end

/*---------------------------------------------------------
   Name: gamemode:PlayerShouldTakeDamage
   Return true if this player should take damage from this attacker
---------------------------------------------------------*/
function GM:PlayerShouldTakeDamage( ply, attacker )
	return true
end

/*---------------------------------------------------------
   Name: gamemode:ContextScreenClick(  aimvec, mousecode, pressed, ply )
   'pressed' is true when the button has been pressed, false when it's released
---------------------------------------------------------*/
function GM:ContextScreenClick( aimvec, mousecode, pressed, ply )
	
	// We don't want to do anything by default, just feed it to the weapon
	local wep = ply:GetActiveWeapon()
	if ( ValidEntity( wep ) && wep.ContextScreenClick ) then
		wep:ContextScreenClick( aimvec, mousecode, pressed, ply )
	end
	
end

/*---------------------------------------------------------
   Name: Text to show in the server browser
---------------------------------------------------------*/
function GM:GetGameDescription()
	return self.Name
end


/*---------------------------------------------------------
   Name: Saved
---------------------------------------------------------*/
function GM:Saved()
end


/*---------------------------------------------------------
   Name: Restored
---------------------------------------------------------*/
function GM:Restored()
end


/*---------------------------------------------------------
   Name: EntityRemoved
   Desc: Called right before an entity is removed. Note that this
   isn't going to be totally reliable on the client since the client
   only knows about entities that it has had in its PVS.
---------------------------------------------------------*/
function GM:EntityRemoved( ent )
end


/*---------------------------------------------------------
   Name: Tick
   Desc: Like Think except called every tick on both client and server
---------------------------------------------------------*/
function GM:Tick()
end

/*---------------------------------------------------------
   Name: OnEntityCreated
   Desc: Called right after the Entity has been made visible to Lua
---------------------------------------------------------*/
function GM:OnEntityCreated( Ent )
end

/*---------------------------------------------------------
   Name: gamemode:EntityKeyValue( ent, key, value )
   Desc: Called when an entity has a keyvalue set
	      Returning a string it will override the value
---------------------------------------------------------*/
function GM:EntityKeyValue( ent, key, value )
end

/*---------------------------------------------------------
   Name: gamemode:CreateTeams()
   Desc: Note - HAS to be shared.
---------------------------------------------------------*/
function GM:CreateTeams()	
	TEAM_CITIZEN = 1
	team.SetUp( TEAM_CITIZEN, "Citizen", Color( 0, 255, 0 ) )
	team.SetSpawnPoint( TEAM_CITIZEN, "info_player_start" )-- example: "info_terrorist"
	
	TEAM_MAYOR = 2
	team.SetUp( TEAM_MAYOR, "Mayor", Color( 255, 150, 0 ) )
	team.SetSpawnPoint( TEAM_MAYOR, "info_player_start" )
	
	TEAM_CP = 3
	team.SetUp( TEAM_CP, "Police", Color( 0, 0, 255 ) )
	team.SetSpawnPoint( TEAM_CP, "info_player_start" )
	
	TEAM_CPCHIEF = 4
	team.SetUp( TEAM_CPCHIEF, "Police Chief", Color( 0, 0, 200 ) )
	team.SetSpawnPoint( TEAM_CPCHIEF, "info_player_start" )
	
	TEAM_STOREKEEPER = 5
	team.SetUp( TEAM_STOREKEEPER, "Store Keeper", Color( 212, 255, 0 ) )
	team.SetSpawnPoint( TEAM_STOREKEEPER, "info_player_start" )
	
	TEAM_DRUGDEALER = 6
	team.SetUp( TEAM_DRUGDEALER, "Citizen", Color( 0, 255, 0 ) )
	team.SetSpawnPoint( TEAM_DRUGDEALER, "info_player_start" )
	
	TEAM_CITIZENF = 7
	team.SetUp( TEAM_CITIZENF, "Citizen", Color( 0, 255, 0 ) )
	team.SetSpawnPoint( TEAM_CITIZENF, "info_player_start" )
	
	TEAM_MEDIC = 8
	team.SetUp( TEAM_MEDIC, "Chemist", Color( 0, 74, 127 ) )
	team.SetSpawnPoint( TEAM_MEDIC, "info_player_start" )
	
	team.SetSpawnPoint( TEAM_SPECTATOR, "worldspawn" ) 

end


/*---------------------------------------------------------
   Name: gamemode:ShouldCollide( Ent1, Ent2 )
   Desc: This should always return true unless you have 
		  a good reason for it not to.
---------------------------------------------------------*/
function GM:ShouldCollide( Ent1, Ent2 )
	/*if Ent1:IsPlayer() and Ent2:IsPlayer() then
		for k, v in pairs ( ents.FindInSphere(Ent1:GetPos(), 20) ) do
			if v == Ent1 then
			v:SetVelocity(Ent2:GetForward() * 100 + Vector(0,500,0))
			end
		end
		return true
	else*/
		return true
--	end
end
